#!/usr/bin/python
import fcntl
import os
import sys
from jobqueue import queueDir, queueLockfile


def lock_queue():
        f=open(os.path.join(queueDir,queueLockfile),'r+')
        fcntl.lockf(f,fcntl.LOCK_EX)

        return f

def unlock_queue(f):
        fcntl.lockf(f,fcntl.LOCK_UN) 
        f.close()


def get_job_list():
        dir = os.listdir(queueDir)
        jobs = [ int(f) for f in dir if f.isdigit() ]

        jobs.sort()

        return jobs


def read_job(job_number):
        jobFileName=os.path.join(queueDir,str(job_number))
        f=open(jobFileName,'r')
        job=f.readlines()
        f.close()
        return job


def remove_job(job_number):
        jobFileName=os.path.join(queueDir,str(job_number))
        print "remove",jobFileName
        os.remove(jobFileName)


def process_all_jobs():
        jobs = get_job_list()

        previous_dns = {}

        for j in reversed(jobs):
                lines = read_job(j)
                action = lines[0].strip()
                dn = lines[1].strip()

                if action == 'U':
                        if dn in previous_dns:
                                remove_job(j)
                        else:
                                previous_dns[dn] = True

               
                       


if __name__ == '__main__':
        lock = lock_queue()
        process_all_jobs()
        unlock_queue(lock)
